import { HapService, AccessoryTypeExecuteResponse } from '../interfaces';
export declare class SecuritySystem {
    twoFactorRequired: boolean;
    returnStateOnExecute: boolean;
    sync(service: HapService): {
        id: string;
        type: string;
        traits: string[];
        name: {
            defaultNames: any[];
            name: string;
            nicknames: any[];
        };
        willReportState: boolean;
        attributes: {
            availableArmLevels: {
                levels: {
                    level_name: string;
                    level_values: {
                        level_synonym: string[];
                        lang: string;
                    }[];
                }[];
                ordered: boolean;
            };
        };
        deviceInfo: {
            manufacturer: any;
            model: any;
        };
        customData: {
            aid: number;
            iid: number;
            instanceUsername: string;
            instanceIpAddress: string;
            instancePort: number;
        };
    };
    query(service: HapService): any;
    execute(service: HapService, command: any): AccessoryTypeExecuteResponse;
    is2faRequired(command: any): boolean;
}
